;
; MIDI-Theremin
;
;  PIC16F84@10MHz
;
; {\[X͏HPA.EXEgCXgNVgpĂ܂B
;	2001.12 (c) 'RUU' ogura
;				http://www.mars.dti.ne.jp/~ogura/
;				ogura@mars.dti.ne.jp
;
; ύX
;		2001.12. (1.0) ŏ̃o[W
;

			.include	16f84.h
			.osc		hs
			.wdt		off
			.pwrt		on
			.protect	off

;;; sATC
;; LCDW[(SC1602)
RS			equ		ra.0
E			equ		ra.1
D4			equ		rb.0
D5			equ		rb.1
D6			equ		rb.2
D7			equ		rb.3

;; A/DRo[^(MCP3204)
CS			equ		ra.2		; `bvZNg
CLK			equ		ra.3		; SPINbN
D_IN		equ		rb.4		; VAf[^(A/Dϊ) MCP3204Dout֐ڑ
D_OUT		equ		rb.5		; VAf[^(`l)o MCP3204Din֐ڑ

;; ̑
MIDI_OUT	equ		ra.4		; MIDIo͒[q
MENU_SW		equ		rb.6		; XCb`(Menu/No)
SET_SW		equ		rb.7		; XCb`(Set/Yes)

;;; 萔
WAIT_CNT	equ		81			; 100uswaitJEg
CNT_BIT		equ		80			; 31.25Kbit/s ^C}[Waitl(bitԊu 32us)

S_NONE		equ		0			; SW̏(sw_val)
S_MENU		equ		1
S_SET		equ		2
S_UP		equ		3
S_DOWN		equ		4

NOTE_C		equ		03ch		; S(= middle C@l)
ON_VEL		equ		060h		; IExVeB(= forte)

T_UP		equ		80			; UP/DOWNXCb`̂l
T_DW		equ		48

LINE1		equ		0			; bZ[We[uPtr.
LINE2		equ		16
MSG_CC		equ		32
MSG_PC		equ		48
MSG_NC		equ		64
LINE3		equ		80
POS_PIT		equ		4			; \J
POS_VOL		equ		4
POS_CH		equ		13
POS_PG		equ		12
POS_VAL		equ		6

			org		0ch

;;; WX^
;; MIDIC^tF[X
midi_msg	ds		5			; MIDIbZ[W
midi_byte	ds		1			; MIDIoCg
msg_len		ds		1			; MbZ[W
bit_cnt		ds		1			; MbitJE^
msb			ds		1
lsb			ds		1			; LSB/MSB (Pitch Bend etc.)
old_msb		ds		1
old_lsb		ds		1
exp			ds		1			; GNXvbV
old_exp		ds		1
note		ds		1			; 
old_note	ds		1
pg			ds		1			; F
old_pg		ds		1
velocity	ds		1			; 
old_vel		ds		1
ch			ds		1			; MIDI CH.
old_ch		ds		1

sw_val		ds		1			; XCb`
cnt			ds		1			; [v񐔃JE^
mode		ds		1			; 샂[h 0:t 1:ݒ

bcdbuf		ds		5			; BCD(10i)i[GA 5bytes
xd32		ds		4			; 32bitZpp[^
xs32		ds		4			; V
y32			ds		4			; V

;; LCD֌W
tx			ds		1			; LCDJ[\ x
ty			ds		1			; LCDJ[\ y
d4			ds		1			; LCDMf[^
d8			ds		1
p_ptr		ds		1
wait_cn		ds		1			; waitJE^
wait_cn2	ds		1


;; A/DRo[^C^tF[X
ch_cntl		ds		1			; MCP3204f[^
d_data		ds		2			; A/Dϊf[^i[
data_buf	ds		1

work		ds		1
wait_cnt	ds		1



wsave		ds		1			; WWX^ޔ
stsave		ds		1			; STATUSޔ


			org		0
			goto	main
			org		4
			goto	intproc

msg_tbl
			jmp		pc+w
			retw	'PIT[0000] CH[00]'		; 0(LINE1)
			retw	'VOL[000] PG[000]'		; 16(LINE2)
			retw	'Channel Change  '		; 32(MSG_CC)
			retw	'Program Change  '		; 48(MSG_PC)
			retw	'Base Note Change'		; 64(MSG_NC)
			retw	'     [Y/N]      '		; 80(LINE3)

num_tbl
			jmp		pc+w
			retw	'0123456789'


;;;;;;;;;;;; 荞ݏ intproc  ;;;;;;;;;;;;

intproc											; 荞ݏ(MIDIoCg̑M)

			mov		wsave,w						; WWX^ޔ
			mov		stsave,status				; STATUSޔ

			sub		tmr0,#CNT_BIT - 2			; tmr0Đݒ(32usԊu)
			clrb	t0if

			cje		bit_cnt,#9,send_strt
			cje		bit_cnt,#0,send_stop
			cje		bit_cnt,#0ffh,int_end

			;; f[^(8bit)M 1bit_cnt8
			rr		midi_byte
			movb	MIDI_OUT,c					; MIDIf[^1bitM
			dec		bit_cnt
			goto	int_end

send_strt
			clrb	MIDI_OUT					; Start bit
			dec		bit_cnt						; bit_cnt = 8
			goto	int_end

send_stop
			setb	MIDI_OUT					; Stop bit
			mov		bit_cnt,#0ffh

int_end		;; ----- 荞ݏI -----
			mov		status,stsave				; STATUS߂
			mov		w,wsave						; W߂
			retfie								; A



;;;;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;
main
			mov		!ra,#00000000b			; ra͑Sďo
			mov		!rb,#11010000b			; D_IN,SW͓
			clr		ra
			clr		rb
			setb	rp0
			mov		option,#00001000b		; RBPU=enable,INT=down_edg,PS=none
			clrb	rp0
			mov		intcon,#00100000b		; ^C}0荞݋AO[o荞݋֎~
			setb	CS
			setb	MIDI_OUT

			mov		note, #NOTE_C			; Note = 'C'
			mov		velocity,#ON_VEL		; Velo. = 'forte'
			clr		pg						; PG = 0 (vOio[1)
			clr		ch						; CH = 0 (`l1)

			call	init_lcd				; LCD

init2
			call	lcd_disp				; LCD\PG,CH\
			call	midi_init
			clr		old_msb
			clr		old_lsb
			clr		old_exp
			clr		mode

mainloop

			;; MenuXCb`̃`FbN
			call	get_sw
			cjne	sw_val,#S_MENU,p_exp
			call	set_opt					; IvVݒ
			goto	init2

p_exp
			mov		ch_cntl,#00001000b		; ADC=VOGh,ch0(Expression)
			call	ad_conv
			call	cv_12to14
			mov		exp,msb					; expA/Dϊ7bitf[^i[
			cje		exp,old_exp,p_pitch

			;; ExpressionύX
			mov		midi_msg[0],#0b0h
			or		midi_msg[0],ch
			mov		midi_msg[1],#0bh
			mov		midi_msg[2],msb
			mov		msg_len,#3
			call	send_midi_msg

			mov		d_data[1],msb
			mov		ty,#1
			mov		tx,#POS_VOL
			call	disp_num3

			cje		exp,#0,p_note_off
			cjne	old_exp,#0,p_pitch
			call	note_on					; Exp0ωNote On
			goto	p_pitch
p_note_off
			call	note_off				; Exp0ɕωNote Off
p_pitch
			mov		old_exp,exp
			mov		ch_cntl,#00001001b		; ADC=VOGh,ch1(Pitch)
			call	ad_conv
			call	cv_12to14				; A/Dϊʂlsb,msbɊe7bitŊi[

			cjne	lsb,old_lsb,pitch_bend
			cjne	msb,old_msb,pitch_bend
			goto	bend_end
pitch_bend
			;; lsbmsbωPitch BendύX
			mov		midi_msg[0],#0e0h
			or		midi_msg[0],ch
			mov		midi_msg[1],lsb
			mov		midi_msg[2],msb
			mov		msg_len,#3
			call	send_midi_msg

			mov		ty,#0
			mov		tx,#POS_PIT
			call	disp_num4

bend_end
			mov		old_msb,msb
			mov		old_lsb,lsb

			goto	mainloop

;;;;;;;;;;; note_on ;;;;;;;;;;;;;
note_on
			
			mov		midi_msg[0],#090h
			or		midi_msg[0],ch
			mov		midi_msg[1],note
			mov		midi_msg[2],velocity
			mov		msg_len,#3
			call	send_midi_msg
			ret

;;;;;;;;;;; note_off ;;;;;;;;;;;;;
note_off
			mov		midi_msg[0],#080h
			or		midi_msg[0],ch
			mov		midi_msg[1],note
			mov		midi_msg[2],velocity
			mov		msg_len,#3
			call	send_midi_msg
			ret

;;;;;;;;;;; lcd_disp ;;;;;;;;;;;;;
lcd_disp									; LCD\
			call	clr_lcd
			clr		ty
			mov		p_ptr,#LINE1
			call	disp_label				; 1sڕ\
			inc		ty
			mov		p_ptr,#LINE2
			call	disp_label				; 2sڕ\
			mov		d_data[1],ch
			mov		ty,#0
			mov		tx,#POS_CH
			call	disp_num2				; CH\(2)
			mov		d_data[1],pg
			mov		ty,#1
			mov		tx,#POS_PG
			call	disp_num3				; PG\(3)
			ret

;;;;;;;;;;; disp_num4 ;;;;;;;;;;;;;
disp_num4	;; LCDɐl(4)\
			clr		xd32[0]
			clr		xd32[1]
			mov		xd32[2],d_data[0]
			mov		xd32[3],d_data[1]
			call	conv_bcd
			mov		fsr,#bcdbuf+1
			mov		cnt,#4
			call	disp_char
			ret

;;;;;;;;;;; disp_num3 ;;;;;;;;;;;;;
disp_num3	;; LCDɐl(3)\
			clr		xd32[0]
			clr		xd32[1]
			clr		xd32[2]
			mov		xd32[3],d_data[1]
			call	conv_bcd
			mov		fsr,#bcdbuf+2
			mov		cnt,#3
			call	disp_char
			ret

;;;;;;;;;;; disp_num2 ;;;;;;;;;;;;;
disp_num2	;; LCDɐl(2)\
			clr		xd32[0]
			clr		xd32[1]
			clr		xd32[2]
			mov		xd32[3],d_data[1]
			call	conv_bcd
			mov		fsr,#bcdbuf+3
			mov		cnt,#2
			call	disp_char
			ret



;;;;;;;;;;; set_opt ;;;;;;;;;;;;;
;; MENUFMIDI Ch̐ݒAF̐ݒA(_)̐ݒ
set_opt
			call	note_off
			call	clr_lcd
			mov		mode,#1

			mov		midi_msg[0],#0e0h		; pitch = _
			or		midi_msg[0],ch
			mov		midi_msg[1],#000h
			mov		midi_msg[2],#040h
			mov		msg_len,#3
			call	send_midi_msg

			mov		midi_msg[0],#0b0h		; Exp. = _
			or		midi_msg[0],ch
			mov		midi_msg[1],#0bh
			mov		midi_msg[2],#040h
			mov		msg_len,#3
			call	send_midi_msg

opt_ch
			clr		ty
			mov		p_ptr,#MSG_CC
			call	disp_label				; 'Channel Change'
			inc		ty
			mov		p_ptr,#LINE3
			call	disp_label
ch_0
			call	get_sw
			cje		sw_val,#S_MENU,opt_pg		; No/Next
			cje		sw_val,#S_SET,select_ch		; Yes/Set
			goto	ch_0
opt_pg
			clr		ty
			mov		p_ptr,#MSG_PC
			call	disp_label				; 'Program Change'
pg_0
			call	get_sw
			cje		sw_val,#S_MENU,opt_note		; No/Next
			cje		sw_val,#S_SET,select_pg		; Yes/Set
			goto	pg_0
opt_note
			clr		ty
			mov		p_ptr,#MSG_NC
			call	disp_label				; 'Note Change'
note_0
			call	get_sw
			cje		sw_val,#S_MENU,opt_end		; No/End
			cje		sw_val,#S_SET,select_note	; Yes/Set
			goto	note_0

select_ch									; `lݒ
			mov		old_ch,ch
ch_loop2
			mov		d_data[1],ch
			mov		ty,#1
			mov		tx,#POS_VAL
			call	disp_num3
ch_loop
			call	get_sw
			cje		sw_val,#S_MENU,ch_end
			cje		sw_val,#S_SET,opt_end
			cje		sw_val,#S_UP,ch_up
			cje		sw_val,#S_DOWN,ch_down
			goto	ch_loop
ch_end
			mov		ch,old_ch
			goto	opt_end
ch_up
			cje		ch,#15,ch_loop
			inc		ch
			goto	ch_loop2
ch_down
			cje		ch,#0,ch_loop
			dec		ch
			goto	ch_loop2

select_pg
			mov		old_pg,pg
pg_loop2
			mov		d_data[1],pg
			mov		ty,#1
			mov		tx,#POS_VAL
			call	disp_num3
			call	note_on
pg_loop
			call	get_sw
			cje		sw_val,#S_MENU,pg_end
			cje		sw_val,#S_SET,opt_end
			cje		sw_val,#S_UP,pg_up
			cje		sw_val,#S_DOWN,pg_down
			goto	pg_loop
pg_end
			mov		pg,old_pg
			goto	opt_end
pg_up
			cje		pg,#127,pg_loop
			inc		pg
			goto	set_pg
pg_down
			cje		pg,#0,pg_loop
			dec		pg
set_pg
			call	note_off
			mov		midi_msg[0],#0c0h		; program change
			or		midi_msg[0],ch
			mov		midi_msg[1],pg
			mov		msg_len,#2
			call	send_midi_msg
			goto	pg_loop2

select_note
			mov		old_note,note
note_loop2
			mov		d_data[1],note
			mov		ty,#1
			mov		tx,#POS_VAL
			call	disp_num3
			call	note_on
note_loop
			call	get_sw
			cje		sw_val,#S_MENU,note_end
			cje		sw_val,#S_SET,opt_end
			cje		sw_val,#S_UP,note_up
			cje		sw_val,#S_DOWN,note_down
			goto	note_loop
note_end
			call	note_off
			mov		note,old_note
			goto	opt_end

note_up
			cje		note,#127,note_loop
			call	note_off
			inc		note
			goto	note_loop2
note_down
			cje		note,#0,note_loop
			call	note_off
			dec		note
			goto	note_loop2

opt_end
			ret


;;;;;;;;;;; get_sw ;;;;;;;;;;;;;
;; SW̏Ԃsw_valɊi[
get_sw
			jnb		MENU_SW,k_menu			; MenuXCb`H
			jnb		SET_SW,k_set			; SetXCb`H
			cje		mode,#0,sw_null
up_dwn
			mov		ch_cntl,#00001010b		; ADC=VOGh,ch2
			call	ad_conv
			call	cv_12to14
			cja		msb,#T_UP,k_up			; UPXCb`H
			cjb		msb,#T_DW,k_dw			; DOWNXCb`H
			goto	sw_null
k_up
			mov		sw_val,#S_UP
			goto	get_sw_end
k_dw
			mov		sw_val,#S_DOWN
			goto	get_sw_end
k_menu
			mov		sw_val,#S_MENU
			goto	off_wait
k_set
			mov		sw_val,#S_SET
			goto	off_wait
get_sw_end
			mov		ch_cntl,#00001010b		; ADC=VOGh,ch2
			call	ad_conv
			call	cv_12to14
			cja		msb,#T_UP,get_sw_end	; UP/DOWN SW܂ő҂
			cjb		msb,#T_DW,get_sw_end
			ret
off_wait
			mov		wait_cnt,#5
			call	wait_10m
			jnb		MENU_SW,off_wait
			jnb		SET_SW,off_wait
			mov		wait_cnt,#5
			call	wait_10m
			ret
sw_null
			mov		sw_val,#S_NONE			; SWĂȂ
			ret

;;;;;;;;;;; midi_init ;;;;;;;;;;;;;
;; MIDIݒ (mFRoland SC-88̂݁B@ł͂ɉKvB)
midi_init
			call	note_off
			;; Pitch Bend Sensitivity (sb`xhɂω}2IN^[uɐݒ)
			mov		midi_msg[0],#0b0h		; RPN LSB
			or		midi_msg[0],ch
			mov		midi_msg[1],#064h
			mov		midi_msg[2],#000h
			mov		msg_len,#3
			call	send_midi_msg
			mov		midi_msg[0],#0b0h		; RPN MSB
			or		midi_msg[0],ch
			mov		midi_msg[1],#065h
			mov		midi_msg[2],#000h
			mov		msg_len,#3
			call	send_midi_msg
			mov		midi_msg[0],#0b0h		; MSB = 18h (24)
			or		midi_msg[0],ch
			mov		midi_msg[1],#006h
			mov		midi_msg[2],#018h
			mov		msg_len,#3
			call	send_midi_msg
			mov		midi_msg[0],#0b0h		; LSB = 00h
			or		midi_msg[0],ch
			mov		midi_msg[1],#026h
			mov		midi_msg[2],#000h
			mov		msg_len,#3
			call	send_midi_msg
			mov		midi_msg[0],#0b0h		; RPN NULL
			or		midi_msg[0],ch
			mov		midi_msg[1],#064h
			mov		midi_msg[2],#07fh
			mov		msg_len,#3
			call	send_midi_msg
			mov		midi_msg[0],#0b0h
			or		midi_msg[0],ch
			mov		midi_msg[1],#065h
			mov		midi_msg[2],#07fh
			mov		msg_len,#3
			call	send_midi_msg
			;; Program# = pg
			mov		midi_msg[0],#0c0h		; program change
			or		midi_msg[0],ch
			mov		midi_msg[1],pg
			mov		msg_len,#2
			call	send_midi_msg
			;; Expression = 0
			mov		midi_msg[0],#0b0h		; Control Change
			or		midi_msg[0],ch
			mov		midi_msg[1],#0bh		; control = Expression
			mov		midi_msg[2],#000h		; Value = 0
			mov		msg_len,#3
			call	send_midi_msg

			ret

;;;;;;;;;;; send_midi_msg ;;;;;;;;;;;;;
;; midi_msgMIDI OUTɑM
send_midi_msg
			mov		fsr,#midi_msg
			mov		tmr0,#255 - CNT_BIT
			setb	gie
send_loop
			mov		midi_byte,indirect
			inc		fsr
			mov		bit_cnt,#9
send_wait
			cjne	bit_cnt,#0ffh,send_wait
			djnz	msg_len,send_loop
			clrb	gie

			ret

;;;;;;;;;;; cv_12to14 ;;;;;;;;;;;
;; d_data12bitf[^MIDIf[^oCg(7bit+7bit)Amsb,lsbɊi[
cv_12to14
			mov		msb,d_data[0]
			mov		lsb,d_data[1]
			swap	msb
			swap	lsb
			and		lsb,#0fh
			and		msb,#0f0h
			or		msb,lsb
			clc
			rr		msb
			mov		lsb,d_data[1]
			rl		lsb
			rl		lsb
			and		lsb,#07ch
			ret

;;;;;;;;;;; ad_conv ;;;;;;;;;;;;;;;
;; ch_cntlŎw肳ꂽ[hE`l̃AiOd12bitfW^ɕϊ,d_dataɊi[
ad_conv
			clr		d_data[0]
			clr		d_data[1]
			setb	CS
			clrb	CLK
			mov		data_buf,ch_cntl
			clrb	CS						; CS=Low
			setb	D_OUT
			setb	CLK
			mov		cnt,#4
cntl_send
			clrb	CLK
			movb	D_OUT,data_buf.3
			rl		data_buf
			setb	CLK
			djnz	cnt,cntl_send

			clrb	CLK
			setb	CLK
			clrb	CLK
			setb	CLK
			clrb	CLK

			mov		cnt,#12
			clc
get_12bit
			setb	CLK
			rl		d_data[1]
			rl		d_data[0]
			movb	d_data[1].0,D_IN
			clrb	CLK
			djnz	cnt,get_12bit

			setb	CS
			ret

;;;;;;;;;;;; disp_char ;;;;; fsrAhXȍ~̕tx,tÿʒucnt\
disp_char
			call	locate
			setb	RS
disp_loop
			mov		d4,indirect
			call	write_lcd4
			inc		fsr
			djnz	cnt,disp_loop
			ret

;;;;;;;;;;;; disp_label ;;;;; 1s̃bZ[W\
disp_label
			clr		tx
			call	locate
			setb	RS
			mov		cnt,#16
label_loop
			mov		w,p_ptr
			call	msg_tbl
			mov		d4,w
			call	write_lcd4
			inc		p_ptr
			djnz	cnt,label_loop
			ret

;;;;;;;;;;;; sw_off ;;;;;;;;;;;;;;;;
sw_off
			mov		wait_cnt,#20
			call	wait_10m
			jnb		MENU_SW,sw_off
			jnb		SET_SW,sw_off
			mov		wait_cnt,#20
			call	wait_10m
			ret

;;;;;;;;;;;; conv_bcd ;;;;;;;;;;;;;;
conv_bcd										; xd32BCD(Char)ϊbcdbuf(5)Ɋi[
			mov		fsr,#bcdbuf+4				; Fxd32,xs32,y32ύX
			clr		y32[0]
			clr		y32[1]
			clr		y32[2]
			mov		y32[3],#10					; y32 = 10
conv_loop
			call	div32						; xd3210̗]bcdbuf5ڂtɊi[
			mov		w,xs32[3]
			call	num_tbl
			mov		indirect,w
			cje		fsr,#bcdbuf,conv_end		; 5ϊ
			dec		fsr
			goto	conv_loop
conv_end
			ret


;;;;;;;;;;;; div32 ;;;;;;;;;;;;;;
div32											; xd32  y32 ̏ xd32ɁA]xs32Ɋi[
			clr		xs32[0]
			clr		xs32[1]
			clr		xs32[2]
			clr		xs32[3]
			mov		cnt,#32
div32_loop
			clc									; L[NA
			rl		xd32[3]						; xd32<<1 bitVtg
			rl		xd32[2]
			rl		xd32[1]
			rl		xd32[0]
			rl		xs32[3]						; ӂxs32ɔ[߂
			rl		xs32[2]
			rl		xs32[1]
			rl		xs32[0]

			mov		W,y32[0]					; xs32 >= yd32?
			subwf	xs32[0],0
			jnc		div32_nxt
			jnz		div32_sub
			mov		W,y32[1]
			subwf	xs32[1],0
			jnc		div32_nxt
			jnz		div32_sub
			mov		W,y32[2]
			subwf	xs32[2],0
			jnc		div32_nxt
			jnz		div32_sub
			mov		W,y32[3]
			subwf	xs32[3],0
			jnc		div32_nxt

div32_sub										; then xs32 = xs32 - y32
			call	sub32
			setb	xd32[3].0					; xd32[3].0̃rbg𗧂Ă

div32_nxt										; else
			djnz	cnt,div32_loop				; 32bit[v
			ret

;;;;;;;;;;;; sub32 ;;;;;;;;;;;;;;
sub32											; xs32  y32 ZAʂxs32Ɋi[
			sub		xs32[3],y32[3]				; xs-y [3] ŏǏvZ
			jc		sub32_2						; ʂȂ[2]vZ
			sub		xs32[2],#1					; ȂǑ1(cOȂdecf͎gȂ)
			jc		sub32_2
			sub		xs32[1],#1
			jc		sub32_2
			dec		xs32[0]
sub32_2
			sub		xs32[2],y32[2]				; [2]̌vZ
			jc		sub32_1
			sub		xs32[1],#1
			jc		sub32_1
			dec		xs32[0]
sub32_1
			sub		xs32[1],y32[1]				; [1]̌vZ
			jc		sub32_0
			dec		xs32[0]
sub32_0
			sub		xs32[0],y32[0]				; [0]̌vZ
			ret



;;;;;;;;;;;;;;;; LCD ;;;;;;;;;;;;;;;;

init_lcd
			mov		wait_cn, #15
			call	wait_ms
			clrb	RS
			mov		d8, #00110000b
			call	write_lcd8
			mov		wait_cn,#5
			call	wait_ms
			mov		d8, #00110000b
			call	write_lcd8
			mov		wait_cn,#100
			call	wait_us
			mov		d8, #00110000b
			call	write_lcd8
			mov		d8, #00100000b
			call	write_lcd8
			mov		d4, #00101000b
			call	write_lcd4
			mov		d4, #00000001b
			call	write_lcd4
			mov		wait_cn,#2
			call	wait_ms
			mov		d4, #00000110b
			call	write_lcd4
			mov		d4, #00001100b	; cursor off
			call	write_lcd4
			ret


clr_lcd
			clrb	RS
			mov		d4, #00000001b
			call	write_lcd4
			mov		wait_cn,#2
			call	wait_ms
			ret

locate
			cje		ty,#1,loc_1
			mov		d4,#080h
			goto	loc_e
loc_1
			mov		d4,#0c0h
loc_e
			add		d4,tx
			clrb	RS
			call	write_lcd4
			ret


write_lcd8
			swap	d8
			and		d8,#00001111b
			and		rb,#11110000b
			or		rb,d8
			nop
			setb	E
			nop
			clrb	E
			mov		wait_cn,#40
			call	wait_us
			ret


write_lcd4
			mov		d8,d4
			call	write_lcd8
			mov		d8,d4
			swap	d8
			call	write_lcd8
			ret

;;;;;;;;;;;;;;;; wait ;;;;;;;;;;;;;;;;

wait_ms
wait_ms0
			mov		wait_cn2,#0
wait_ms1
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			djnz	wait_cn2,wait_ms1
			djnz	wait_cn,wait_ms0
			ret

wait_us
wait_us0
			djnz	wait_cn,wait_us0
			ret

;;;;;;;;;;;; wait100 ; 100s * cnt Ԃ ;;;;;;;;;;;;
wait100
			mov		work,#WAIT_CNT
loop100
			decsz	work
			goto	loop100
			decsz	cnt
			goto	wait100
			ret

;;;;;;;;;;;; wait1_10m ; 10ms * wait_cnt ;;;;;;;;;;;;
wait_10m
			mov		cnt,#100
			call	wait100
			decsz	wait_cnt
			goto	wait_10m
			ret

;;;;;;;;;;;;;;;;;;; ܂ ;;;;;;;;;;;;;;;;;;;;;;
